<template>
  <div>
    <!-- <pre>{{ config }}</pre> -->
    <h4>{{ title }}</h4>
    <!-- {{ fieldsConfig }} -->

    <div v-if="!options.hideField">
      <select-field :node="node" :path="[...path, '_type']" :config="config" default-label="-- Select type --" @change="typeChanged"></select-field>
      <!-- <pre>{{ config }}</pre> -->

      <!-- <pre>{{ path }}</pre> -->
      <!-- <pre>{{ node }}</pre> -->
      <div v-if="type">
        {{ config.ref[type].label }}
        <items-form :title="config.ref[type].label" :node="node" :path="path" :config="config.ref[type]"></items-form>
      </div>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapGetters, mapActions } from 'vuex'

import { EDITABLE_FIELD_CONFIG } from '@/components/Editable/config'

import SelectField from '@/components/Editable/Fields/Widgets/SelectWidgetField'

export default {
  components: {
    SelectField,
    ItemsForm: () => import('./ItemsForm.vue')
  },

  props: {
    title: {
      type: String,
      required: true
    },
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // config: {
    //   type: Object,
    //   required: true
    // },
    // options: {
    //   type: Object,
    //   required: false,
    //   default: () => {}
    // }
  },

  data () {
    return {
    }
  },
  // watch: {
  //   type () {
  //     if (this.type) {
  //       this.updateMultipleEditableFieldsData({ data: { node: this.node, path: this.path, config: this.config.ref[this.type].fields } })
  //     }
  //   }
  // },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    parentConfig () {
      return this.getFieldConfig({ node: this.node, path: (this.path || []).slice(0, -1) })
    },

    options () {
      return this.getFieldOptions({
        parentConfig: this.parentConfig,
        config: this.config,
        node: this.node,
        path: this.path,
        parentData: this.getEditedField({ node: this.node, path: (this.path || []).slice(0, -1) }),
        data: this.getEditedField({ node: this.node, path: this.path })
      })
    },

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    type () {
      return this.getEditedField({ node: this.node, path: [...this.path, '_type'] })
    },

    nodeData () {
      return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, {})
    }

    // fieldsConfig () {
    //   return this.config.fields || {}
    // }
    // ...mapGetters({
    //   getEditableNodes: 'Y3TI/getEditableNodes',
    //   getFieldConfig: 'Y3TI/getFieldConfig'
    // }),

    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    ...mapActions({
      changeEditableParagraphType: 'Y3TI/changeEditableParagraphType'
    }),

    getFieldOptions: EDITABLE_FIELD_CONFIG,

    typeChanged () {
      if (this.type) {
        this.changeEditableParagraphType({ data: { node: this.node, path: this.path, config: this.config, type: this.type } })
        // this.updateMultipleEditableFieldsData({ data: { node: this.node, path: this.path, config: this.config.ref[this.type].fields } })
      }
    }

    // ...mapActions({
    //   storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    // }),

    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  }
}
</script>

<style lang="scss" scoped>
</style>
